<template>
    <RouterLink tag="div" :to="'/projects/' + project.projectId" class="card text-decoration-none" :style="cardStyle">
        <div class="card-body text-white">
            <h4 class="card-title">#{{project.projectId}} {{ project.name }}</h4>
            <strong v-if="project.price">{{formattedPrice}}</strong>
        </div>
        <form @submit.prevent="saveNewName" class="card-footer d-flex align-items-center">
            <input v-model="newName" type="text" class="form-control" placeholder="Neuer Name">
            <button type="submit" class="btn btn-primary">Speichern</button>
        </form>
    </RouterLink>
</template>

<script setup>
    import {computed, ref, watch} from "vue";

    const FALLBACK_IMAGE = 'https://images.pexels.com/photos/18801976/pexels-photo-18801976/free-photo-of-mann-sitzung-baum-fluss.jpeg?auto=compress&cs=tinysrgb&w=1260&h=750&dpr=1'
    const EUR_FORMATTER = new Intl.NumberFormat('de-AT', {currency: 'EUR', style: 'currency'})

    const props = defineProps({
        project: Object
    })

    const emit = defineEmits(['update', 'delete'])

    const newName = ref('')

    const cardStyle = computed(() => {
        return {
            background: `url(${props.project.image ?? FALLBACK_IMAGE})`
        }
    })

    const formattedPrice = computed(() => EUR_FORMATTER.format(props.project.price))

    function saveNewName(event) {
        console.log(event)
        emit('update', props.project.projectId, newName.value)
        newName.value = ''
    }

    watch(() => props.project.name, () => {
        newName.value = props.project.name
        console.log('Formatted price changed')
    }, {immediate: true})

    watch(newName, () => {
        if(newName.value.length < 3) {
            return
        }
        console.log('Load autocomplete suggestions')
    })
</script>